#!/usr/bin/env python
#-*- coding:utf-8 -*-

from __future__ import print_function, unicode_literals, division, absolute_import

import sys
import io
from glob import glob
try:
    import folia.main as folia
except ImportError:
    print("The FoLiA Python library is required to run this script: pip install folia",file=sys.stderr)
    sys.exit(3)

print("Generating Relax NG schema")
folia.relaxng('folia-min.rng')

#!/usr/bin/python
data = io.open("folia-min.rng",'r',encoding='utf-8').readlines()
data.insert(1,"""<!--
RelaxNG schema for FoLiA XML v%s
    by Maarten van Gompel
    Centre for Language and Speech Technology
    Radboud University Nijmegen

    https://proycon.github.io/folia
    https://github.com/proycon/folia

    Schema version %s
      (auto-generated by foliapy)

    Validation examples:
     $ xmllint ‒‒relaxng folia.rng foliadocument.xml
     $ jing folia.rng foliadocument.xml

    However, it is strongly recommended to use the foliavalidator tool instead,
    as it does extra validation that can not be captured by RelaxNG!

    $ foliavalidator foliadocument.xml

    Licensed under the GNU General Public License v3
-->
""" %  (folia.FOLIAVERSION, folia.LIBVERSION))
io.open('folia.rng','w',encoding='utf-8').writelines(data)


print("Validating example documents...", file=sys.stderr)
for filename in glob("../examples/*.folia.xml"):
    print(" Validating " + filename,file=sys.stderr)
    folia.validate(filename)
    print("   OK!",file=sys.stderr)
